package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.dao.custom.base.impl.FindConverterDao;
import com.jasamedika.medifirst2000.entities.PapMuskuloskeletal;
import com.jasamedika.medifirst2000.vo.PapMuskuloskeletalVO;

/**
 * Converter class PAPMuskuloskeletal
 * 
 * @author Askur
 */
@Component
public class PapMuskuloskeletalConverter extends FindConverterDao implements
		BaseVoConverter<PapMuskuloskeletalVO, PapMuskuloskeletal> {

	public PapMuskuloskeletal transferVOToModel(PapMuskuloskeletalVO vo, PapMuskuloskeletal model) {
		if (null == model)
			model = new PapMuskuloskeletal();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, PapMuskuloskeletal.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return model;

	}

	public List<PapMuskuloskeletalVO> transferListOfModelToListOfVO(List<PapMuskuloskeletal> models,
			List<PapMuskuloskeletalVO> vos) {
		if (null == vos)
			vos = new ArrayList<PapMuskuloskeletalVO>();

		if (null == models)
			return vos;

		for (PapMuskuloskeletal model : models) {
			PapMuskuloskeletalVO vo = new PapMuskuloskeletalVO();
			transferModelToVO(model, vo);
			vos.add(vo);
		}

		return vos;
	}

	public PapMuskuloskeletalVO transferModelToVO(PapMuskuloskeletal model, PapMuskuloskeletalVO vo) {
		if (null == vo)
			vo = new PapMuskuloskeletalVO();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, PapMuskuloskeletalVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return vo;
	}
	
}
